* This routine uses ExcelListener to output a report as an Excel sheet.
PROCEDURE Frx2Excel_ExcelListener
LPARAMETERS tcReport,tuWorkbookFile,tcWorksheetName,tcOptions,tcDescription

#IF .F.

* Developer can indicate properties by placing values in Comment field in this format: <ExcelCol>18</ExcelCol>
* To get numeric 1 or 0 must write it as 1. or 0., otherwise Fox interprets as .T. / .F.
	* <ExcelCol>18</ExcelCol>				- Indicates ExcelCol for this and other items with same Left
	* <ExcelSpecialCol>18</ExcelSpecialCol> - Indicates ExcelCol for one item only
	* <ExcelMergeAcross>99</ExcelMergeAcross>
	* <ExcelColWidth>50</ExcelColWidth>              

*!* ExcelBorders format: <ExcelBorders>Top,Single,1;Bottom,Double,3</ExcelBorders>
*!*	   <Borders>
*!*	    <Border ss:Position="Top" ss:LineStyle="Continuous" ss:Weight="1"/>
*!*	    <Border ss:Position="Bottom" ss:LineStyle="Double" ss:Weight="3"/>
*!*	   </Borders>

*!* Interior properties.
*!*		Color		 = Background Color
*!*		Pattern		 = "Solid" --> no pattern, "Gray125", "ThinVert ss:Pattern="Solid"Stripe"
*!*		PatternColor
*!* Samples:
*!*	<ExcelInterior>Solid,FFFF00</ExcelInterior>
*!*		<Interior ss:Color="#FFFF00" ss:Pattern="Gray125"/>
*!*	<ExcelInterior>Gray125,FFFFFF,000000</ExcelInterior>
*!*		<Interior ss:Color="#FFFFFF" ss:Pattern="Gray125" ss:PatternColor="#000000"/>
*!*	<ExcelInterior>ThinVertStripe,FFFF00,00FF00</ExcelInterior>
*!*		<Interior ss:Color="#FFFF00" ss:Pattern="ThinVertStripe" ss:PatternColor="#00FF00"/>

*!* ExcelNamedRange format: <ExcelNamedRange>Name;Range</ExcelNamedRange>
*!*		<Names>
*!* 	  <NamedRange ss:Name="Cajas_Per1" ss:RefersTo="=Sheet1!R10C7"/>
*!*		  <NamedRange ss:Name="Cajas_Per2" ss:RefersTo="=Sheet1!R10C13"/>
*!* 	/Names>

*!* ExcelInsertFormula format: <ExcelInsertFormula>Formula preceded by =</ExcelInsertFormula>
*!!	<Cell ss:StyleID="s70" ss:Formula="=+(RC[-4]+RC[-3]) / Cajas_Per2"><Data ss:Type="Number">36.025570039331619</Data></Cell>


* Codify report colors as <ExcelInterior>Solid,xxxxxx</ExcelInterior> and store in cExcelInterior

		   00000 AS nExcelColRequest,00000 AS nExcelSpecialColRequest,00000 AS nExcelMergeAcross, ;
		   00000.00 AS nExcelColWidth,SPACE(50) AS cExcelAlignment, ;
		   SPACE(100) AS cExcelBorder,SPACE(100) AS cExcelInterior, ;
		   0 AS nUnderlinedColCount, ;


#ENDIF


	* Setup
	IF EMPTY(tcOptions)
		tcOptions = ''
	ENDIF
	LOCAL lcReportBehavior,loPreviewContainer,loExtensionHandler,loReportListener
	lcReportBehavior = SET("ReportBehavior")
	SET REPORTBEHAVIOR 90
	* Set up report listener
	loReportListener = NEWOBJECT("ExcelListener","ExcelListener.vcx")
	loReportListener.ListenerType = 3	&& ?
	loReportListener.lOutputToCursor = .T.
	loReportListener.cWorkbookFile	= tuWorkbookFile
	loReportListener.cWorksheetName = tcWorksheetName
	loReportListener.ThermFormCaption = tcDescription
	loReportListener.cExcelStyle = 'MyExcelStyle_1'

	* Run a report:
	REPORT FORM (tcReport) OBJECT loReportListener &tcOptions

	SET REPORTBEHAVIOR &lcReportBehavior


PROCEDURE MyExcelStyle_1
LPARAMETERS tnOption,toListener
LOCAL lcOutputAlias

*  0 = Title 
*  1 = Page header
*  2 = Column header
*  3 = Group header
*  4 = Detail
*  5 = Group footer
*  6 = Column footer
*  7 = Page footer
*  8 = Summary

lcOutputAlias = toListener.cOutputAlias
DO CASE
	CASE tnOption = 1	&& Before extracting comments

	CASE tnOption = 2	&& Before assigning row
		DELETE ALL FOR (cUser = '  0' OR cUser = '  1') ;
						AND ('FECHA DE IMPRESION:' $ cExpr OR 'FECHA DE IMPRESIN:' $ cExpr  OR 'FECHA:' $ cExpr OR 'FECHA :' $ cExpr ;
							 OR 'PAGINA:' $ cExpr OR 'PGINA:' $ cExpr ;
							 OR cExpr = 'DATE()' OR cExpr = 'DATETIME()' OR cExpr = 'TIME()' OR cExpr = '_PAGENO') ;
						AND nPageNo > 0
							 
*		DELETE ALL FOR (cUser = '  0' OR cUser = '  1') ;
						AND ('PAGINA:' $ cExpr OR 'PGINA:' $ cExpr OR cExpr = '_PAGENO')
*		DELETE ALL FOR (cUser = '  0' OR cUser = '  1') ;
						AND ('FECHA DE IMPRESION:' $ cExpr OR 'FECHA DE IMPRESIN:' $ cExpr ;
							 OR cExpr = 'DATE()' OR cExpr = 'TIME()') ;
						AND nPageNo > 1

	CASE tnOption = 3	&& Before assigning col

	CASE tnOption = 4	&& After assigning row and column
		* Cursores con las filas y columnas
		SELECT DISTINCT ExcelRow,LEFT(User,3) AS User ;
		  FROM (lcOutputAlias) ;
		  INTO ARRAY laRowUser
		CREATE CURSOR ExcelCols (ExcelCol N(3))
		FOR i = 1 TO pnMaxCol
			INSERT INTO ExcelCols (ExcelCol) VALUES(i)
		ENDFOR

		* Lista de celdas con --- or ===
		SELECT ExcelRow,ExcelCol,Contents,User,cUser ;
		  FROM (lcOutputAlias) ;
		 WHERE (LEFT(cContents,3) = '===' AND EMPTY(CHRTRAN(cContents,'=',''))) ;
		 	   OR (LEFT(cContents,3) = '---' AND EMPTY(CHRTRAN(cContents,'-','')));
		  INTO CURSOR DashedCells READWRITE

		* Cells to underline (one line above --- or ===)
		SELECT ExcelRow - 1 AS ExcelRow,ExcelCol,Contents,User,cUser,.F. AS lNueva ;
		  FROM DashedCells ;
		  INTO CURSOR UnderlinedCells READWRITE

		* Borramos celdas con --- or ===
		DELETE &lcOutputAlias ;
		  FROM DashedCells ;
		 WHERE &lcOutputAlias..ExcelRow = DashedCells.ExcelRow AND &lcOutputAlias..ExcelCol = DashedCells.ExcelCol

		* Add line extensions
		SELECT UnderlinedCells
		SCAN FOR INT(LEN(ALLTRIM(Contents)) / 8) > 1 AND !lNueva
			lnRecno	   = RECNO()
			lnExcelRow = ExcelRow
			lcContents = LEFT(Contents,5)
			lcUser	   = User
			lcCUser	   = cUser
			FOR i = 1 TO INT(LEN(ALLTRIM(Contents)) / 8)
				lnExcelCol = UnderlinedCells.ExcelCol + i
				IF lnExcelCol > pnMaxCol
					EXIT
				ENDIF
				LOCATE FOR ExcelRow = lnExcelRow AND ExcelCol = lnExcelCol
				IF EOF()
					j = ASCAN(laRowUser,lnExcelRow,1,ALEN(laRowUser,1),1,8)
					lcUser  = IIF(j > 0,laRowUser[j,2],lcUser)
					lcCUser = IIF(j > 0,laRowUser[j,2],lcCUser)
					INSERT INTO UnderlinedCells ;
								(ExcelRow,  ExcelCol,  Contents,  User, cUser, lNueva) ;
						 VALUES (lnExcelRow,lnExcelCol,lcContents,lcUser,lcCUser,.T.)
				ENDIF
				GOTO (lnRecno) IN UnderlinedCells
			ENDFOR
		ENDSCAN
		
		* Add missing cells that need to be underlined
		SELECT U.* ;
		  FROM UnderlinedCells U ;
		 WHERE NOT EXISTS (SELECT OA.ExcelRow,OA.ExcelCol ;
		 					 FROM (lcOutputAlias) OA ;
		 					WHERE OA.ExcelRow = U.ExcelRow ;
		 						  AND OA.ExcelCol = U.ExcelCol) ;
		  INTO CURSOR MissingCells
		SELECT (lcOutputAlias)
		APPEND FROM DBF('MissingCells') FIELDS ExcelRow,ExcelCol,User,cUser
		SET ORDER TO RowCol

		* Perform underline
		SELECT UnderlinedCells
		SET RELATION TO TRANSFORM(ExcelRow,'@L 999999') + TRANSFORM(ExcelCol,'@L 999999') INTO (lcOutputAlias)
		REPLACE ALL &lcOutputAlias..cExcelBorder WITH 'Bottom,' ;
					+ IIF(LEFT(ALLTRIM(Contents),3)='===','Double,3','')
*		REPLACE ALL cExcelBorder WITH 'Bottom,' + IIF(LEFT(ALLTRIM(Contents),3)='===','Double,3','') ;
				 IN &lcOutputAlias
		SET RELATION TO

		* Eliminate dashed Excel rows that became empty (move up following cells)
		SELECT (lcOutputAlias)
		SET ORDER TO
		SELECT DISTINCT ExcelRow + 0000000 AS ExcelRow ;
		  FROM DashedCells ;
		 WHERE ExcelRow NOT IN (SELECT ExcelRow ;
		 						  FROM (lcOutputAlias)) ;
		 GROUP BY 1 ;
		 ORDER BY 1 ;
		  INTO CURSOR RenglonesParaEliminar READWRITE
		APPEND BLANK
		REPLACE ExcelRow WITH 9999999
		GO TOP
		lnFirstRow = 0
		SCAN
			SELECT (lcOutputAlias)
			REPLACE ALL ExcelRow WITH ExcelRow - RECNO('RenglonesParaEliminar') + 1 ;
					FOR BETWEEN(ExcelRow,lnFirstRow,RenglonesParaEliminar.ExcelRow)
			lnFirstRow = RenglonesParaEliminar.ExcelRow
		ENDSCAN

		* If nExcelMergeAcross >=99 merges to rightmost column
		SELECT (lcOutputAlias)
		REPLACE ALL nExcelMergeAcross WITH pnMaxCol - ExcelCol ;
				FOR nExcelMergeAcross >=99

		* Font
		REPLACE ALL FontFace WITH 'Arial', ;
					FontSize WITH MAX(FontSize,10)		&& Minimum font is 10
		REPLACE ALL FontSize WITH 16 ;
				FOR (cUser = '  0' OR cUser = '  1') ;
					AND ObjType = 8 ;
					AND 'SIS.CNOMBRE' $ cExpr
		REPLACE ALL FontStyle WITH 1 ;
				FOR cUser <= '  2' ;
					AND (ObjType = 5 OR ObjType = 8)
		REPLACE ALL FontStyle WITH 1 + 2 ;
				FOR cUser = '  3' ;
					AND (ObjType = 5 OR ObjType = 8)

		* Group Footer
		* Creamos celdas vacias que faltan
		LOCAL laRowsGroupFooter[1]
		laRowsGroupFooter = 0
		lcCols = 0
		SELECT DISTINCT ExcelRow ;
		  FROM (lcOutputAlias) ;
		 WHERE cUser = '  5' ;
		  INTO ARRAY laRowsGroupFooter
		FOR i = 1 TO ALEN(laRowsGroupFooter,1)
			IF EMPTY(laRowsGroupFooter[i])
				LOOP
			ENDIF
			lnRow = laRowsGroupFooter[i]
			FOR lnCol = 1 TO pnMaxCol
				LOCATE FOR ExcelRow = lnRow AND ExcelCol = lnCol
				IF EOF()
					APPEND BLANK
					REPLACE ExcelRow WITH lnRow, ;
							ExcelCol WITH lnCol, ;
							User	 WITH '  5', ;
							cUser	 WITH '  5'
				ELSE
					* Si la celda existia nos aseguramos que este marcada como GroupFooter
					REPLACE	User	 WITH '  5', ;
							cUser	 WITH '  5'
				ENDIF
			ENDFOR
		ENDFOR
 		
		* Report total
		* Creamos celdas vacias que faltan
		LOCAL laReportTotal[1]
		laReportTotal = 0
		lcCols = 0
		SELECT DISTINCT ExcelRow ;
		  FROM (lcOutputAlias) ;
		 WHERE cUser = '  8' ;
		  INTO ARRAY laReportTotal
		FOR i = 1 TO ALEN(laReportTotal,1)
			IF EMPTY(laReportTotal[i])
				LOOP
			ENDIF
			lnRow = laReportTotal[i]
			FOR lnCol = 1 TO pnMaxCol
				LOCATE FOR ExcelRow = lnRow AND ExcelCol = lnCol
				IF EOF()
					APPEND BLANK
					REPLACE ExcelRow WITH lnRow, ;
							ExcelCol WITH lnCol, ;
							User	 WITH '  8', ;
							cUser	 WITH '  8'
				ENDIF
			ENDFOR
		ENDFOR
 		
		* Decoramos GroupFooter ( User = '  5')
		* Font y background
		REPLACE ALL FontStyle WITH 1 ;
				FOR cUser = '  5' ;
					AND (ObjType = 5 OR ObjType = 8)
		REPLACE ALL cExcelInterior WITH 'Solid,';
										+ RIGHT(TRANSFORM(RGB(192,192,192),'@0'),6) + ',' ;
										+ RIGHT(TRANSFORM(RGB(0,0,0),'@0'),6) ;
				FOR cUser = '  5'

		* Decoramos ReportTotal ( User = '  8')
		* Font y background
		REPLACE ALL FontStyle WITH 1 ;
				FOR cUser = '  8' ;
					AND (ObjType = 5 OR ObjType = 8)
		REPLACE ALL cExcelInterior WITH 'Solid,';
										+ RIGHT(TRANSFORM(RGB(150,150,150),'@0'),6) + ',' ;
										+ RIGHT(TRANSFORM(RGB(0,0,0),'@0'),6) ;
				FOR cUser = '  8'

		* Bordes arriba y abajo
		LOCAL laGroupFooters[1,2]
		laGroupFooters[1,1] = 0
		laGroupFooters[1,2] = ''
		SELECT DISTINCT ExcelRow,SPACE(8) AS cExcelBorder ;
		  FROM (lcOutputAlias) ;
		 WHERE cUser = '  5' ;
		  INTO ARRAY laGroupFooters
		lnLastRow	  = 0
		FOR i = 1 TO ALEN(laGroupFooters,1)
			IF EMPTY(laGroupFooters[i,1])
				LOOP
			ENDIF
			DO CASE
				CASE lnLastRow = 0
					laGroupFooters[i,2] = 'Top,Single,1'
				CASE laGroupFooters[i,1] = lnLastRow + 1
					laGroupFooters[i,2] = 'Top,Single,1'
				OTHERWISE	&& laGroupFooters[i,1] > lnLastRow + 1
					laGroupFooters[i-1,2] = laGroupFooters[i-1,2] ;
										   + IIF(EMPTY(laGroupFooters[i-1,2]),'',';') ;
										   + 'Bottom,Double,3'
					laGroupFooters[i,2]   = 'Top,Single,1'
			ENDCASE			
			lnLastRow = laGroupFooters[i,1]
		ENDFOR
		laGroupFooters[ALEN(laGroupFooters,1),2] = laGroupFooters[ALEN(laGroupFooters,1),2] ;
							   + IIF(EMPTY(laGroupFooters[ALEN(laGroupFooters,1),2]),'',';') ;
							   + 'Bottom,Double,3'
		
		lnRecno		  = 0
		SCAN FOR User = '  5'
			i = ASCAN(laGroupFooters,ExcelRow,1,ALEN(laGroupFooters,1),1,8)
			IF i = 0
				LOOP
			ENDIF
			REPLACE cExcelBorder WITH laGroupFooters[i,2]
			lnRecno = RECNO()
		ENDSCAN
ENDCASE